var NOT_IE = (typeof window.showModalDialog == 'undefined'); // Hack for NOT-IE detection
var IS_MOBILE = /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini|Mobile|mobile|CriOS/i.test(navigator.userAgent) || (navigator.platform === 'MacIntel' && navigator.maxTouchPoints > 1);

var IS_SAFARI = false;

var ua = navigator.userAgent.toLowerCase(); 
if (ua.indexOf('safari') != -1) { 
  if (ua.indexOf('chrome') == -1) {
    IS_SAFARI = true;
  }
}

function SafariFocusMessage(){
	if (IS_SAFARI) {
		// Give some time to finish the touch event before showing the message to prevent double messages
		setTimeout(function() {
			alert("Module is already opened, please move to the module tab.");	
		}, 100);
	}
}

function OpenHome(){
	if (IS_SAFARI) {
		// Give some time to finish the touch event before showing the message to prevent double messages
		setTimeout(function() {
			alert("Home is already opened, please move to the home tab.");
		}, 100);
	}

	window.focusOpen('', 'STARTWINDOW').focus();
}

var startWindow = (function(){
	var hasConsole = ("undefined" != typeof console);
	var found = false;
	var cantFind = false;
	var startMenu = top;
	if ((typeof startMenu === "undefined") || (startMenu.name !== 'STARTWINDOW')) {
		if(typeof top.startWindow !== "undefined"){
			startMenu = top.startWindow;
		}
	}
	if ((typeof startMenu === "undefined") || (startMenu.name !== 'STARTWINDOW')) {
		if(top.opener){
			if(typeof top.opener.startWindow !== "undefined"){
				startMenu = top.opener.startWindow;
			}else{//if it is open from a frame, send the frame startWindow instance
				if(typeof top.opener.OpenModule !== "undefined") {
					startMenu = top.opener;	
				}
				else {
					startMenu = top.opener.STARTWINDOW || top.opener;
				}
			}
		}
	}
	if ((typeof startMenu === "undefined") || (startMenu.name !== 'STARTWINDOW')) {
		startMenu = top;
		var attempts = 0;
		while ((!found) && (!cantFind) && (attempts < 255)) {
			attempts++;
			try {
				startMenu = (startMenu.top.dialogArguments || startMenu.top.opener);
			} catch (e) {
				cantFind = true;
			}
			try {
				// property if the domain is different (LGXReports/Shadow)
				found = (startMenu.name === 'STARTWINDOW');
			} catch (e) {}
		}
	} else {
		found = true;
	}
	
	if (!found) {
		hasConsole && console.log("Unable to find STARTWINDOW");
		startMenu = null;
	}
	return startMenu || undefined;
})(); 

function getUrlParameterByName(name) {
	var url = window.location.href;
    name = name.replace(/[\[\]]/g, '\\$&');
	var regex = new RegExp('[?&]' + name + '(=([^&#]*)|&|#|$)');
	results = regex.exec(url);
    if (!results) return null;
    if (!results[2]) return '';
    return decodeURIComponent(results[2].replace(/\+/g, ' '));
}

function getCookie(name) {
  var value = '; ' + document.cookie;
  var parts = value.split('; ' + name + '=');
  if (parts.length === 2) return parts.pop().split(';').shift();
}

function setCookie(name, value, optionsParam) {
  var options = optionsParam || {};
  options.path = '/';

  if (options.expires instanceof Date) {
    options.expires = options.expires.toUTCString();
  }

  var updatedCookie = encodeURIComponent(name) + "=" + encodeURIComponent(value);

  for (var optionKey in options) {
    updatedCookie += "; " + optionKey;
    var optionValue = options[optionKey];
    if (optionValue !== true) {
      updatedCookie += "=" + optionValue;
    }
  }

  document.cookie = updatedCookie;
}

//RVAL is not used right now, we are sending it in case we will need to validate the code to modify the class with different colors
function manageRequiredAndNonRequiredChrome(REQ, NRQ, RVAL, prefix){
	if (NOT_IE) {
		// Set fields to be required
		if (REQ !== 0) {
			var LIST = REQ.split('|');
			for (var i = 0; i < LIST.length; i++) {
				RDE = LIST[i];
				TYP = RDE.slice(0, 1);
				DDE = prefix+RDE.slice(1, 99);
				if ((TYP === 'R') || (TYP === 'C')) {
					var elements = document.getElementsByName(DDE);
					if(elements){
						for (var j = 0; j < elements.length; j++) {
							var element = elements[j];
							addRequiredElementChrome(element, true)
						}
					}else{
						LGTH = document.all[DDE].length + 1;
						if (LGTH <= 0) {
							LGTH = 2 ;
						}

						for (var j = 1; j < LGTH; j++) {
							ELE = DDE + TYP + j ;
							addRequiredElementChrome(document.all[ELE], true)
						}
					}
				}
			}
		}

		// Set fields to no longer be required
		if (NRQ !== 0) {
			var LIST = NRQ.split('|');
			for (var i=0; i < LIST.length; i++) {
				RDE = LIST[i];
				TYP = RDE.slice(0, 1);
				DDE = prefix+RDE.slice(1, 99);
				if ((TYP === 'R') || (TYP === 'C')) {
					var elements = document.getElementsByName(DDE);
					if(elements){
						for (var j = 0; j < elements.length; j++) {
							var element = elements[j];
							removeRequiredElementChrome(element)
						}
					}else{
						LGTH = document.all[DDE].length + 1;
						if (LGTH <= 0) {
							LGTH = 2 ;
						}

						for (var j = 1; j < LGTH; j++) {
							ELE = DDE + TYP + j ;
							removeRequiredElementChrome(document.all[ELE])
						}
					}
				}
			}
		}
	}
}

function addRequiredElementChrome(domElement, explicitRequired) {
	var style = domElement.attributes["style"];

	if (explicitRequired || ((domElement.type == 'radio' || domElement.type == 'checkbox') && style && (style.textContent.toUpperCase().replace(/ /g,'').includes("BACKGROUND-COLOR:RGB(255,208,208)") || style.textContent.toUpperCase().replace(/ /g,'').includes("BACKGROUND-COLOR:#FFD0D0")))) {		
		var divId = "divRequired" + domElement.id + domElement.name;
		var parentElement = domElement.parentElement;
		
		if(parentElement.id == divId){
			parentElement.setAttribute("class", "requiredElementChrome");
		}else{
			var newNode = document.createElement('div');
			newNode.setAttribute("class", "requiredElementChrome");
			newNode.setAttribute("id", divId);
			parentElement.insertBefore(newNode, domElement);
			newNode.appendChild(domElement);
		}
	}
}

function removeRequiredElementChrome(domElement) {
	if(domElement.type == 'radio' || domElement.type == 'checkbox'){
		domElement.parentElement.setAttribute("class", "nonRequiredElementChrome");
	}
}

function validateGuidCookie() {
	if (NOT_IE) {
		var guid = getUrlParameterByName('guid');
		if (guid && !getCookie('guid')) {
			var d = new Date();
  			d.setTime(d.getTime() + (1*60*60*1000));
  			var expires = d.toUTCString()
			document.cookie = 'guid=' + guid + ';expires=' + expires + ';path=/';
		}
	}
}

(function() {
	// Helpers
	var canDefineGetters = !!(Object && Object.prototype && Object.prototype.__defineGetter__);
	var hasConsole = ("undefined" != typeof console);
	var handleError = function(e) {
		if (hasConsole) {
			console.log(e);
		} else {
			throw(e);
		}
	}

	validateGuidCookie();

	if ("undefined" !== typeof window.HTMLElement) {
		// Shim: <HTMLElement>.name
		// TODO: Need to detect if (HTMLElement).name will exist (it's not a part of the prototype normally)
		try {
			if (canDefineGetters) {
				HTMLElement.prototype.__defineGetter__("name",function() {
					return this.getAttribute("name");
				});

				HTMLElement.prototype.__defineSetter__("name",function(val) {
					return this.setAttribute("name", val);
				});
			} else {
				hasConsole && console.log('Unable to define HTMLElement.prototype.name');
			}
		} catch (e) {
			handleError(e);
		}

		// Shim: <HTMLElement>.all
		if (!HTMLElement.prototype.hasOwnProperty('all')) {
			try {
				if (canDefineGetters) {
					HTMLElement.prototype.__defineGetter__("all",function() {
						var descendants = function(element) {
							// [].slice.call() - HTMLCollection to Array
							var children = [].slice.call(element.children), found = 0;
							while (children.length > found) {
								children = children.concat([].slice.call(children[found].children));
								found++;
							}
							return children;
					   };
		 
						var all = descendants(this);
						var length = all.length; // Save length to avoid issue when adding new elements with numeric IDs
						for (var i = 0; i < length; i++) {
							if (all[i].id) {
								all[all[i].id] = all[i];
							}
							if (all[i].name) {
								if (all[all[i].name]) {
									if (all[all[i].name].constructor.name != "Array") {
										if(all[all[i].name] !== all[all[i].id]){
											all[all[i].name] = [all[all[i].name]];
										}
									}
									
									if(all[all[i].name] !== all[all[i].id]){
										all[all[i].name].push(all[i]);
									}
								} else {
									all[all[i].name] = all[i];
								}
							}
						}
		 
						return all;
					});
				} else {
					hasConsole && console.log('Unable to define HTMLElement.prototype.all');
				}
			} catch (e) {
				handleError(e);
			}
		}
	}

	if ('undefined' != typeof Document) {
		// Shim: <Document>.selection
		// TODO: This is an improper implementation of <Document>.selection, but it works for what we need
		if (!Document.prototype.hasOwnProperty('selection')) {
			Document.prototype.selection = {}
			Document.prototype.selection.empty = function() {}
		}
	}

	if (!String.prototype.includes) {
		String.prototype.includes = function(search, start) {
		  'use strict';
	  
		  if (search instanceof RegExp) {
			throw TypeError('first argument must not be a RegExp');
		  }
		  if (start === undefined) { start = 0; }
		  return this.indexOf(search, start) !== -1;
		};
	  }

	window.EventCache = function(){
		var listEvents = [];
		return {
			listEvents : listEvents,
			add : function(){
				listEvents.push(arguments);
			},
			remove: function(){
				var i, item;

				for (var i = listEvents.length - 1; i >= 0; i--) {
					item = listEvents[i];

					if (item[0] == arguments[0] && item[1] == arguments[1] && item[2] == arguments[2]) {						

						listEvents.splice(i);
						return;
					}
				}
			},
			flush : function(){
				var i, item;
				for(i = listEvents.length - 1; i >= 0; i = i - 1){
					item = listEvents[i];
					if(item[0].removeEventListener){
						item[0].removeEventListener(item[1], item[2], item[3]);
					};
					if(item[1].substring(0, 2) != "on"){
						item[1] = "on" + item[1];
					};
					if(item[0].detachEvent){
						item[0].detachEvent(item[1], item[2]);
					};
					item[0][item[1]] = null;
					item[0]["e_"+item[1]+"_ctr"] = null;
				};
			}
		};
	}();

	window.addEvent = function( obj, type, fn ) {
		type = type.substring(0,2) == "on" ? type.substring(2) : type;
		var eventType = "on"+type;

		if (obj.addEventListener) {
			obj.addEventListener( type, fn, false );
			EventCache.add(obj, type, fn);
		} else if (obj.attachEvent) {
			obj.attachEvent( eventType, fn );
			EventCache.add(obj, type, fn);
		} else {
			var nextCtr = (obj["e_"+eventType+"_ctr"] || 0) + 1;
			if ((nextCtr == 1) && (typeof obj[eventType] == 'function')) {
				obj["e_"+eventType+"_"+nextCtr] = obj[eventType];
				nextCtr = nextCtr + 1;
				obj[eventType] = function(){
					var returnValue;
					var count = obj["e_"+eventType+"_ctr"];
					for (var i = 1; i <= count; i++) {
						returnValue = Function.prototype.apply.apply(obj["e_"+eventType+"_"+i], [window, arguments]);
					}
					return returnValue;
				};
			}
			obj["e_"+eventType+"_ctr"] = nextCtr;
			obj["e_"+eventType+"_"+nextCtr] = fn;
		}
	}

	window.removeEvent = function(obj, type, fn) {
		type = type.substring(0,2) == "on" ? type.substring(2) : type;
		var eventType = "on"+type;
		
		if(obj.removeEventListener){
			obj.removeEventListener(type, fn, false);
		};

		if(obj.detachEvent){
			obj.detachEvent(eventType, fn);
		};

		obj[eventType] = null;
		obj["e_"+eventType+"_ctr"] = null;

		EventCache.remove(obj, type, fn);
    }
	
	if (NOT_IE) { // IE gets "Permission Denied" error intermittently when opening Dev Tools (we aren't trying to patch IE's behavior anyway)
		//TODO: This instance return an array in case the element is got it from getElementById
		//this means the NodeList properties will not be there.
		document._oldgetElementsByName = document.getElementsByName;
		document._oldgetElementById = document.getElementById;
		
		document.getElementsByName = function(elemIdOrName) {
			var result = document._oldgetElementsByName(elemIdOrName);
			if (!result || result.length <= 0) {
				var elem = document._oldgetElementById(elemIdOrName); 
				if (elem) {
					result= [elem];
				}
			}

			return result;
		};

		document.getElementById = function(elemIdOrName) {
			var result = document._oldgetElementById(elemIdOrName);
			if (!result) {
				var elem = document._oldgetElementsByName(elemIdOrName); 
				if (elem && elem.length > 0) {
					result = elem[0];
				}
			}

			return result;
		};

		// On pages where autoplayAudioEnabled is set, play an inaudible tone to keep the tab from freezing OR discarding
		(function(){
			if (typeof autoplayAudioEnabled == "undefined") {
				autoplayAudioEnabled = false;
			}
			var audioStarted = false;
			var StartAudio = function StartAudio(){
				if (top.autoplayAudioEnabled && !audioStarted) {
					// create web audio api context
					var audioCtx = new (window.AudioContext || window.webkitAudioContext)();

					// create Oscillator node
					var oscillator = audioCtx.createOscillator();
					oscillator.frequency.setValueAtTime(top.FREQUENCY || 20, audioCtx.currentTime); // value in hertz

					// create volume control
					var gainNode = audioCtx.createGain();
					gainNode.gain.setTargetAtTime(top.VOLUME || 0.001, audioCtx.currentTime, 0.001); // 0.1%
					
					// connect audio elements
					gainNode.connect(audioCtx.destination);
					oscillator.connect(gainNode);
					
					// start audio
					oscillator.start();
					audioStarted = true;
					removeEvent(window, 'click', StartAudio);
				}
			};
			addEvent(window, 'click', StartAudio);
		})();
	}

	var openInNewWindow = function(event) {
		var href = event.currentTarget.href;
		var target = event.currentTarget.target;
		if (target == "_blank") {
			event.preventDefault();
			window.open(href, target, "resizable");
		}
	};

	window.openedWindows = [];
	addEvent(window, 'load', function(){
		if (NOT_IE) {
			var elements = document.querySelector("a");
			if(elements){
				elements.addEventListener("click", openInNewWindow);
			}

			var radiosAndChecks = document.getElementsByTagName("input");
			for (i = 0; i < radiosAndChecks.length; i++) {
				addRequiredElementChrome(radiosAndChecks[i]);
			}
		}

		// Track Windows
		var oldOpen = window.open;
		window.focusOpen = function(){
			return Function.prototype.apply.apply(oldOpen, [window, arguments]);
		};
		window.open = function(url, windowName, windowFeatures){
			if(windowFeatures){
				if(!windowFeatures.includes("resizable")){
					windowFeatures = windowFeatures+",resizable";
				}
			}else{
				windowFeatures = "resizable";
			}
			var newWindow = oldOpen(url, windowName, windowFeatures);
			if(!newWindow || newWindow.closed || typeof newWindow.closed=='undefined') { 
				setCookie('popupsAllowed', '0', {'max-age': 3600});
			} else {
				setCookie('popupsAllowed', '1', {'max-age': 3600});
			}
			window.openedWindows.push(newWindow);
			return newWindow;
		};
		// Track Alerts
		var oldAlert = window.alert;
		window.alert = function(){
			var startTime = (new Date()).getTime();
			var alertReturn = Function.prototype.apply.apply(oldAlert, [window, arguments]);
			var stopTime = (new Date()).getTime();
			if (typeof sessDebug !== 'undefined') { sessDebug.push('Alert opened for ' + (stopTime - startTime) + 'ms: ' + arguments[0]); }
			return alertReturn;
		};
	});

	addEvent(window, 'unload', function(){
		var newWindow;
		while (newWindow = window.openedWindows.shift()) {
			if (newWindow && !newWindow.closed) {
				newWindow.close();
			}
		}
	});

	addEvent(document, 'keydown', function(e){
		e = e || window.event;
		if (e) {
			var cancelEvent = false;
			switch (e.keyCode) {
				case 8: // Backspace
					if ((e.srcElement.type != 'text') && (e.srcElement.type != 'password') && (e.srcElement.type != 'textarea') && (e.srcElement.type != 'search') || (e.srcElement.readOnly)) {
						cancelEvent = true;
					}
					break;
				case 13: // Enter
					if (!window.allowEnter && e.srcElement.type != 'textarea') {
						cancelEvent = true;
					}
					break;
				case 116: // F5
				case 192: // Tilde
					cancelEvent = true;
			}
			if (cancelEvent) {
				e.cancelBubble = true;
				e.returnValue = false;
				return false;
			}
		}
	});

	var found = false;
	var cantFind = false;
	var startMenu = startWindow;
	if ((typeof startMenu !== "undefined") && (startMenu.name === 'STARTWINDOW')) {
		found = true;
	}
	if (found && typeof(startMenu.activityHandler) != 'undefined'){
		var timeoutHandle = null;
		var activityHandler = function(){
			timeoutHandle = timeoutHandle || setTimeout(function(){
				clearTimeout(timeoutHandle);
				startMenu.activityHandler();
				timeoutHandle = null;
			},5000);
		};
		addEvent(document, 'keypress', activityHandler);
		addEvent(document, 'mousedown', activityHandler);
	}

	// Polyfill window.showModalDialog and window.showModelessDialog
	// Added a new method called closeModal to manage the function when is IE or Chrome

	window.closeModal = function(){
		if (NOT_IE){
			if(window.frameElement){
				window.frameElement.parentElement.close()
			}
		}else{
			window.close();
		}
	};

    window.showModalDialogThornBerry = function(url, arg, opt, callbackFunction) {
    	if (window.showModalDialog){
    		var result = window.showModalDialog(url, arg, opt);
    		if(callbackFunction){
					callbackFunction(result);
				}
    	} else {
    			var windowForModal = window;
    			
    			if (window.name != "MAIN") {
    				if(parent.frames["MAIN"]){
    					windowForModal = parent.frames["MAIN"];
    				}
    			}
    			
	        url = url || ''; //URL of a dialog
	        arg = arg || null; //arguments to a dialog
	        opt = opt || 'dialogWidth:660px;dialogHeight:600px'; //options: dialogTop;dialogLeft;dialogWidth;dialogHeight or CSS styles
	        var caller = showModalDialogThornBerry.caller.toString();
	        var dialog = windowForModal.document.createElement('dialog');
	        dialogPolyfill.registerDialog(dialog);
	        windowForModal.document.body.appendChild(dialog);
	        dialog.setAttribute('style', opt.replace(/dialog/gi, '').replace(/=/g, ':'));
	        var uniqueCloseId = "dialog-close" + Date.now();
	        var uniquebodyId = "dialog-body" + Date.now();
	        dialog.innerHTML = '<a href="#" id="' + uniqueCloseId + '" style="position: absolute; top: 0; right: 5px; font-size: 32px; color: #000; text-decoration: none; outline: none;">&times;</a><iframe id="' + uniquebodyId + '" src="' + url + '" style="border: 0; width: 100%; height: 100%;"></iframe>';
	        windowForModal.document.getElementById(uniquebodyId).contentWindow.dialogArguments = arg;
	        windowForModal.document.getElementById(uniqueCloseId).addEventListener('click', function(e) {
	            e.preventDefault();
	            dialog.close();
	        });
			dialog.addEventListener('close', function() {
				if(callbackFunction){
					var dialogFrame = windowForModal.document.getElementById(uniquebodyId);
					var returnValue = dialogFrame.contentWindow.returnValue;
					if(returnValue){
						windowForModal.document.body.removeChild(dialog);
						callbackFunction(returnValue);
					}else{
						windowForModal.document.body.removeChild(dialog);
						callbackFunction();
					}
				}
			});

	        dialog.showModal();
        }
    };

})();



if (NOT_IE) {
	var jsDialogPolyfill = '(function (global, factory) {' +
	'typeof exports === \'object\' && typeof module !== \'undefined\' ? module.exports = factory() :' +
	'typeof define === \'function\' && define.amd ? define(factory) :' +
	'(global = global || self, global.dialogPolyfill = factory());' +
	'}(this, function () { \'use strict\';' +
	'var supportCustomEvent = window.CustomEvent;' +
	'if (!supportCustomEvent || typeof supportCustomEvent === \'object\') {' +
	'supportCustomEvent = function CustomEvent(event, x) {' +
	'x = x || {};' +
	'var ev = document.createEvent(\'CustomEvent\');' +
	'ev.initCustomEvent(event, !!x.bubbles, !!x.cancelable, x.detail || null);' +
	'return ev;' +
	'};' +
	'supportCustomEvent.prototype = window.Event.prototype;' +
	'}' +
	'function safeDispatchEvent(target, event) {' +
	'var check = \'on\' + event.type.toLowerCase();' +
	'if (typeof target[check] === \'function\') {' +
	'target[check](event);' +
	'}' +
	'return target.dispatchEvent(event);' +
	'}' +
	'function createsStackingContext(el) {' +
	'while (el && el !== document.body) {' +
	'var s = window.getComputedStyle(el);' +
	'var invalid = function(k, ok) {' +
	'return !(s[k] === undefined || s[k] === ok);' +
	'};' +
	'if (s.opacity < 1 ||' +
	'invalid(\'zIndex\', \'auto\') ||' +
	'invalid(\'transform\', \'none\') ||' +
	'invalid(\'mixBlendMode\', \'normal\') ||' +
	'invalid(\'filter\', \'none\') ||' +
	'invalid(\'perspective\', \'none\') ||' +
	's[\'isolation\'] === \'isolate\' ||' +
	's.position === \'fixed\' ||' +
	's.webkitOverflowScrolling === \'touch\') {' +
	'return true;' +
	'}' +
	'el = el.parentElement;' +
	'}' +
	'return false;' +
	'}' +
	'function findNearestDialog(el) {' +
	'while (el) {' +
	'if (el.localName === \'dialog\') {' +
	'return (el);' +
	'}' +
	'if (el.parentElement) {' +
	'el = el.parentElement;' +
	'} else if (el.parentNode) {' +
	'el = el.parentNode.host;' +
	'} else {' +
	'el = null;' +
	'}' +
	'}' +
	'return null;' +
	'}' +
	'function safeBlur(el) {' +
	'while (el && el.shadowRoot && el.shadowRoot.activeElement) {' +
	'el = el.shadowRoot.activeElement;' +
	'}' +
	'if (el && el.blur && el !== document.body) {' +
	'el.blur();' +
	'}' +
	'}' +
	'function inNodeList(nodeList, node) {' +
	'for (var i = 0; i < nodeList.length; ++i) {' +
	'if (nodeList[i] === node) {' +
	'return true;' +
	'}' +
	'}' +
	'return false;' +
	'}' +
	'function isFormMethodDialog(el) {' +
	'if (!el || !el.hasAttribute(\'method\')) {' +
	'return false;' +
	'}' +
	'return el.getAttribute(\'method\').toLowerCase() === \'dialog\';' +
	'}' +
	'function findFocusableElementWithin(hostElement) {' +
	'var opts = [\'button\', \'input\', \'keygen\', \'select\', \'textarea\'];' +
	'var query = opts.map(function(el) {' +
	'return el + \':not([disabled])\';' +
	'});' +
	'query.push(\'[tabindex]:not([disabled]):not([tabindex=""])\');' +
	'var target = hostElement.querySelector(query.join(\', \'));' +
	'if (!target && \'attachShadow\' in Element.prototype) {' +
	'var elems = hostElement.querySelectorAll(\'*\');' +
	'for (var i = 0; i < elems.length; i++) {' +
	'if (elems[i].tagName && elems[i].shadowRoot) {' +
	'target = findFocusableElementWithin(elems[i].shadowRoot);' +
	'if (target) {' +
	'break;' +
	'}' +
	'}' +
	'}' +
	'}' +
	'return target;' +
	'}' +
	'function isConnected(element) {' +
	'return element.isConnected || document.body.contains(element);' +
	'}' +
	'function findFormSubmitter(event) {' +
	'if (event.submitter) {' +
	'return event.submitter;' +
	'}' +
	'var form = event.target;' +
	'if (!(form instanceof HTMLFormElement)) {' +
	'return null;' +
	'}' +
	'var submitter = dialogPolyfill.formSubmitter;' +
	'if (!submitter) {' +
	'var target = event.target;' +
	'var root = (\'getRootNode\' in target && target.getRootNode() || document);' +
	'submitter = root.activeElement;' +
	'}' +
	'if (!submitter || submitter.form !== form) {' +
	'return null;' +
	'}' +
	'return submitter;' +
	'}' +
	'function maybeHandleSubmit(event) {' +
	'if (event.defaultPrevented) {' +
	'return;' +
	'}' +
	'var form =  (event.target);' +
	'var value = dialogPolyfill.imagemapUseValue;' +
	'var submitter = findFormSubmitter(event);' +
	'if (value === null && submitter) {' +
	'value = submitter.value;' +
	'}' +
	'var dialog = findNearestDialog(form);' +
	'if (!dialog) {' +
	'return;' +
	'}' +
	'var formmethod = submitter && submitter.getAttribute(\'formmethod\') || form.getAttribute(\'method\');' +
	'if (formmethod !== \'dialog\') {' +
	'return;' +
	'}' +
	'event.preventDefault();' +
	'if (value != null) {' +
	'dialog.close(value);' +
	'} else {' +
	'dialog.close();' +
	'}' +
	'}' +
	'function dialogPolyfillInfo(dialog) {' +
	'this.dialog_ = dialog;' +
	'this.replacedStyleTop_ = false;' +
	'this.openAsModal_ = false;' +
	'if (!dialog.hasAttribute(\'role\')) {' +
	'dialog.setAttribute(\'role\', \'dialog\');' +
	'}' +
	'dialog.show = this.show.bind(this);' +
	'dialog.showModal = this.showModal.bind(this);' +
	'dialog.close = this.close.bind(this);' +
	'dialog.addEventListener(\'submit\', maybeHandleSubmit, false);' +
	'if (!(\'returnValue\' in dialog)) {' +
	'dialog.returnValue = \'\';' +
	'}' +
	'if (\'MutationObserver\' in window) {' +
	'var mo = new MutationObserver(this.maybeHideModal.bind(this));' +
	'mo.observe(dialog, {attributes: true, attributeFilter: [\'open\']});' +
	'} else {' +
	'var removed = false;' +
	'var cb = function() {' +
	'removed ? this.downgradeModal() : this.maybeHideModal();' +
	'removed = false;' +
	'}.bind(this);' +
	'var timeout;' +
	'var delayModel = function(ev) {' +
	'if (ev.target !== dialog) { return; }' +
	'var cand = \'DOMNodeRemoved\';' +
	'removed |= (ev.type.substr(0, cand.length) === cand);' +
	'window.clearTimeout(timeout);' +
	'timeout = window.setTimeout(cb, 0);' +
	'};' +
	'[\'DOMAttrModified\', \'DOMNodeRemoved\', \'DOMNodeRemovedFromDocument\'].forEach(function(name) {' +
	'dialog.addEventListener(name, delayModel);' +
	'});' +
	'}' +
	'Object.defineProperty(dialog, \'open\', {' +
	'set: this.setOpen.bind(this),' +
	'get: dialog.hasAttribute.bind(dialog, \'open\')' +
	'});' +
	'this.backdrop_ = document.createElement(\'div\');' +
	'this.backdrop_.className = \'backdrop\';' +
	'this.backdrop_.addEventListener(\'mouseup\'  , this.backdropMouseEvent_.bind(this));' +
	'this.backdrop_.addEventListener(\'mousedown\', this.backdropMouseEvent_.bind(this));' +
	'this.backdrop_.addEventListener(\'click\'    , this.backdropMouseEvent_.bind(this));' +
	'}' +
	'dialogPolyfillInfo.prototype = ({' +
	'get dialog() {' +
	'return this.dialog_;' +
	'},' +
	'maybeHideModal: function() {' +
	'if (this.dialog_.hasAttribute(\'open\') && isConnected(this.dialog_)) { return; }' +
	'this.downgradeModal();' +
	'},' +
	'downgradeModal: function() {' +
	'if (!this.openAsModal_) { return; }' +
	'this.openAsModal_ = false;' +
	'this.dialog_.style.zIndex = \'\';' +
	'if (this.replacedStyleTop_) {' +
	'this.dialog_.style.top = \'\';' +
	'this.replacedStyleTop_ = false;' +
	'}' +
	'this.backdrop_.parentNode && this.backdrop_.parentNode.removeChild(this.backdrop_);' +
	'dialogPolyfill.dm.removeDialog(this);' +
	'},' +
	'setOpen: function(value) {' +
	'if (value) {' +
	'this.dialog_.hasAttribute(\'open\') || this.dialog_.setAttribute(\'open\', \'\');' +
	'} else {' +
	'this.dialog_.removeAttribute(\'open\');' +
	'this.maybeHideModal();' +
	'}' +
	'},' +
	'backdropMouseEvent_: function(e) {' +
	'if (!this.dialog_.hasAttribute(\'tabindex\')) {' +
	'var fake = document.createElement(\'div\');' +
	'this.dialog_.insertBefore(fake, this.dialog_.firstChild);' +
	'fake.tabIndex = -1;' +
	'fake.focus();' +
	'this.dialog_.removeChild(fake);' +
	'} else {' +
	'this.dialog_.focus();' +
	'}' +
	'var redirectedEvent = document.createEvent(\'MouseEvents\');' +
	'redirectedEvent.initMouseEvent(e.type, e.bubbles, e.cancelable, window,' +
	'e.detail, e.screenX, e.screenY, e.clientX, e.clientY, e.ctrlKey,' +
	'e.altKey, e.shiftKey, e.metaKey, e.button, e.relatedTarget);' +
	'this.dialog_.dispatchEvent(redirectedEvent);' +
	'e.stopPropagation();' +
	'},' +
	'focus_: function() {' +
	'var target = this.dialog_.querySelector(\'[autofocus]:not([disabled])\');' +
	'if (!target && this.dialog_.tabIndex >= 0) {' +
	'target = this.dialog_;' +
	'}' +
	'if (!target) {' +
	'target = findFocusableElementWithin(this.dialog_);' +
	'}' +
	'safeBlur(document.activeElement);' +
	'target && target.focus();' +
	'},' +
	'updateZIndex: function(dialogZ, backdropZ) {' +
	'if (dialogZ < backdropZ) {' +
	'throw new Error(\'dialogZ should never be < backdropZ\');' +
	'}' +
	'this.dialog_.style.zIndex = dialogZ;' +
	'this.backdrop_.style.zIndex = backdropZ;' +
	'},' +
	'show: function() {' +
	'if (!this.dialog_.open) {' +
	'this.setOpen(true);' +
	'this.focus_();' +
	'}' +
	'},' +
	'showModal: function() {' +
	'if (this.dialog_.hasAttribute(\'open\')) {' +
	'throw new Error(\'Failed to execute showModal on dialog: The element is already open, and therefore cannot be opened modally.\');' +
	'}' +
	'if (!isConnected(this.dialog_)) {' +
	'throw new Error(\'Failed to execute showModal on dialog: The element is not in a Document.\');' +
	'}' +
	'if (!dialogPolyfill.dm.pushDialog(this)) {' +
	'throw new Error(\'Failed to execute showModal on dialog: There are too many open modal dialogs.\');' +
	'}' +
	'if (createsStackingContext(this.dialog_.parentElement)) {' +
	'console.warn(\'A dialog is being shown inside a stacking context. This may cause it to be unusable. For more information, see this link: https://github.com/GoogleChrome/dialog-polyfill/#stacking-context\');' +
	'}' +
	'this.setOpen(true);' +
	'this.openAsModal_ = true;' +
	'if (dialogPolyfill.needsCentering(this.dialog_)) {' +
	'dialogPolyfill.reposition(this.dialog_);' +
	'this.replacedStyleTop_ = true;' +
	'} else {' +
	'this.replacedStyleTop_ = false;' +
	'}' +
	'this.dialog_.parentNode.insertBefore(this.backdrop_, this.dialog_.nextSibling);' +
	'this.focus_();' +
	'},' +
	'close: function(opt_returnValue) {' +
	'if (!this.dialog_.hasAttribute(\'open\')) {' +
	'throw new Error(\'Failed to execute close on dialog: The element does not have an open attribute, and therefore cannot be closed.\');' +
	'}' +
	'this.setOpen(false);' +
	'if (opt_returnValue !== undefined) {' +
	'this.dialog_.returnValue = opt_returnValue;' +
	'}' +
	'var closeEvent = new supportCustomEvent(\'close\', {' +
	'bubbles: false,' +
	'cancelable: false' +
	'});' +
	'safeDispatchEvent(this.dialog_, closeEvent);' +
	'}' +
	'});' +
	'var dialogPolyfill = {};' +
	'dialogPolyfill.reposition = function(element) {' +
	'var scrollTop = document.body.scrollTop || document.documentElement.scrollTop;' +
	'var topValue = scrollTop + (window.innerHeight - element.offsetHeight) / 2;' +
	'element.style.top = Math.max(scrollTop, topValue) + \'px\';' +
	'};' +
	'dialogPolyfill.isInlinePositionSetByStylesheet = function(element) {' +
	'for (var i = 0; i < document.styleSheets.length; ++i) {' +
	'var styleSheet = document.styleSheets[i];' +
	'var cssRules = null;' +
	'try {' +
	'cssRules = styleSheet.cssRules;' +
	'} catch (e) {}' +
	'if (!cssRules) { continue; }' +
	'for (var j = 0; j < cssRules.length; ++j) {' +
	'var rule = cssRules[j];' +
	'var selectedNodes = null;' +
	'try {' +
	'selectedNodes = document.querySelectorAll(rule.selectorText);' +
	'} catch(e) {}' +
	'if (!selectedNodes || !inNodeList(selectedNodes, element)) {' +
	'continue;' +
	'}' +
	'var cssTop = rule.style.getPropertyValue(\'top\');' +
	'var cssBottom = rule.style.getPropertyValue(\'bottom\');' +
	'if ((cssTop && cssTop !== \'auto\') || (cssBottom && cssBottom !== \'auto\')) {' +
	'return true;' +
	'}' +
	'}' +
	'}' +
	'return false;' +
	'};' +
	'dialogPolyfill.needsCentering = function(dialog) {' +
	'var computedStyle = window.getComputedStyle(dialog);' +
	'if (computedStyle.position !== \'absolute\') {' +
	'return false;' +
	'}' +
	'if ((dialog.style.top !== \'auto\' && dialog.style.top !== \'\') ||' +
	'(dialog.style.bottom !== \'auto\' && dialog.style.bottom !== \'\')) {' +
	'return false;' +
	'}' +
	'return !dialogPolyfill.isInlinePositionSetByStylesheet(dialog);' +
	'};' +
	'dialogPolyfill.forceRegisterDialog = function(element) {' +
	'if (window.HTMLDialogElement || element.showModal) {' +
	'console.warn(\'This browser already supports <dialog>, the polyfill may not work correctly\', element);' +
	'}' +
	'if (element.localName !== \'dialog\') {' +
	'throw new Error(\'Failed to register dialog: The element is not a dialog.\');' +
	'}' +
	'new dialogPolyfillInfo((element));' +
	'};' +
	'dialogPolyfill.registerDialog = function(element) {' +
	'if (!element.showModal) {' +
	'dialogPolyfill.forceRegisterDialog(element);' +
	'}' +
	'};' +
	'dialogPolyfill.DialogManager = function() {' +
	'this.pendingDialogStack = [];' +
	'var checkDOM = this.checkDOM_.bind(this);' +
	'this.overlay = document.createElement(\'div\');' +
	'this.overlay.className = \'_dialog_overlay\';' +
	'this.overlay.addEventListener(\'click\', function(e) {' +
	'this.forwardTab_ = undefined;' +
	'e.stopPropagation();' +
	'checkDOM([]);' +
	'}.bind(this));' +
	'this.handleKey_ = this.handleKey_.bind(this);' +
	'this.handleFocus_ = this.handleFocus_.bind(this);' +
	'this.zIndexLow_ = 100000;' +
	'this.zIndexHigh_ = 100000 + 150;' +
	'this.forwardTab_ = undefined;' +
	'if (\'MutationObserver\' in window) {' +
	'this.mo_ = new MutationObserver(function(records) {' +
	'var removed = [];' +
	'records.forEach(function(rec) {' +
	'for (var i = 0, c; c = rec.removedNodes[i]; ++i) {' +
	'if (!(c instanceof Element)) {' +
	'continue;' +
	'} else if (c.localName === \'dialog\') {' +
	'removed.push(c);' +
	'}' +
	'removed = removed.concat(c.querySelectorAll(\'dialog\'));' +
	'}' +
	'});' +
	'removed.length && checkDOM(removed);' +
	'});' +
	'}' +
	'};' +
	'dialogPolyfill.DialogManager.prototype.blockDocument = function() {' +
	'document.documentElement.addEventListener(\'focus\', this.handleFocus_, true);' +
	'document.addEventListener(\'keydown\', this.handleKey_);' +
	'this.mo_ && this.mo_.observe(document, {childList: true, subtree: true});' +
	'};' +
	'dialogPolyfill.DialogManager.prototype.unblockDocument = function() {' +
	'document.documentElement.removeEventListener(\'focus\', this.handleFocus_, true);' +
	'document.removeEventListener(\'keydown\', this.handleKey_);' +
	'this.mo_ && this.mo_.disconnect();' +
	'};' +
	'dialogPolyfill.DialogManager.prototype.updateStacking = function() {' +
	'var zIndex = this.zIndexHigh_;' +
	'for (var i = 0, dpi; dpi = this.pendingDialogStack[i]; ++i) {' +
	'dpi.updateZIndex(--zIndex, --zIndex);' +
	'if (i === 0) {' +
	'this.overlay.style.zIndex = --zIndex;' +
	'}' +
	'}' +
	'var last = this.pendingDialogStack[0];' +
	'if (last) {' +
	'var p = last.dialog.parentNode || document.body;' +
	'p.appendChild(this.overlay);' +
	'} else if (this.overlay.parentNode) {' +
	'this.overlay.parentNode.removeChild(this.overlay);' +
	'}' +
	'};' +
	'dialogPolyfill.DialogManager.prototype.containedByTopDialog_ = function(candidate) {' +
	'while (candidate = findNearestDialog(candidate)) {' +
	'for (var i = 0, dpi; dpi = this.pendingDialogStack[i]; ++i) {' +
	'if (dpi.dialog === candidate) {' +
	'return i === 0;' +
	'}' +
	'}' +
	'candidate = candidate.parentElement;' +
	'}' +
	'return false;' +
	'};' +
	'dialogPolyfill.DialogManager.prototype.handleFocus_ = function(event) {' +
	'var target = event.composedPath ? event.composedPath()[0] : event.target;' +
	'if (this.containedByTopDialog_(target)) { return; }' +
	'if (document.activeElement === document.documentElement) { return; }' +
	'event.preventDefault();' +
	'event.stopPropagation();' +
	'safeBlur((target));' +
	'if (this.forwardTab_ === undefined) { return; }' +
	'var dpi = this.pendingDialogStack[0];' +
	'var dialog = dpi.dialog;' +
	'var position = dialog.compareDocumentPosition(target);' +
	'if (position & Node.DOCUMENT_POSITION_PRECEDING) {' +
	'if (this.forwardTab_) {' +
	'dpi.focus_();' +
	'} else if (target !== document.documentElement) {' +
	'document.documentElement.focus();' +
	'}' +
	'}' +
	'return false;' +
	'};' +
	'dialogPolyfill.DialogManager.prototype.handleKey_ = function(event) {' +
	'this.forwardTab_ = undefined;' +
	'if (event.keyCode === 27) {' +
	'event.preventDefault();' +
	'event.stopPropagation();' +
	'var cancelEvent = new supportCustomEvent(\'cancel\', {' +
	'bubbles: false,' +
	'cancelable: true' +
	'});' +
	'var dpi = this.pendingDialogStack[0];' +
	'if (dpi && safeDispatchEvent(dpi.dialog, cancelEvent)) {' +
	'dpi.dialog.close();' +
	'}' +
	'} else if (event.keyCode === 9) {' +
	'this.forwardTab_ = !event.shiftKey;' +
	'}' +
	'};' +
	'dialogPolyfill.DialogManager.prototype.checkDOM_ = function(removed) {' +
	'var clone = this.pendingDialogStack.slice();' +
	'clone.forEach(function(dpi) {' +
	'if (removed.indexOf(dpi.dialog) !== -1) {' +
	'dpi.downgradeModal();' +
	'} else {' +
	'dpi.maybeHideModal();' +
	'}' +
	'});' +
	'};' +
	'dialogPolyfill.DialogManager.prototype.pushDialog = function(dpi) {' +
	'var allowed = (this.zIndexHigh_ - this.zIndexLow_) / 2 - 1;' +
	'if (this.pendingDialogStack.length >= allowed) {' +
	'return false;' +
	'}' +
	'if (this.pendingDialogStack.unshift(dpi) === 1) {' +
	'this.blockDocument();' +
	'}' +
	'this.updateStacking();' +
	'return true;' +
	'};' +
	'dialogPolyfill.DialogManager.prototype.removeDialog = function(dpi) {' +
	'var index = this.pendingDialogStack.indexOf(dpi);' +
	'if (index === -1) { return; }' +
	'this.pendingDialogStack.splice(index, 1);' +
	'if (this.pendingDialogStack.length === 0) {' +
	'this.unblockDocument();' +
	'}' +
	'this.updateStacking();' +
	'};' +
	'dialogPolyfill.dm = new dialogPolyfill.DialogManager();' +
	'dialogPolyfill.formSubmitter = null;' +
	'dialogPolyfill.imagemapUseValue = null;' +
	'if (window.HTMLDialogElement === undefined) {' +
	'var testForm = document.createElement(\'form\');' +
	'testForm.setAttribute(\'method\', \'dialog\');' +
	'if (testForm.method !== \'dialog\') {' +
	'var methodDescriptor = Object.getOwnPropertyDescriptor(HTMLFormElement.prototype, \'method\');' +
	'if (methodDescriptor) {' +
	'var realGet = methodDescriptor.get;' +
	'methodDescriptor.get = function() {' +
	'if (isFormMethodDialog(this)) {' +
	'return \'dialog\';' +
	'}' +
	'return realGet.call(this);' +
	'};' +
	'var realSet = methodDescriptor.set;' +
	'methodDescriptor.set = function(v) {' +
	'if (typeof v === \'string\' && v.toLowerCase() === \'dialog\') {' +
	'return this.setAttribute(\'method\', v);' +
	'}' +
	'return realSet.call(this, v);' +
	'};' +
	'Object.defineProperty(HTMLFormElement.prototype, \'method\', methodDescriptor);' +
	'}' +
	'}' +
	'document.addEventListener(\'click\', function(ev) {' +
	'dialogPolyfill.formSubmitter = null;' +
	'dialogPolyfill.imagemapUseValue = null;' +
	'if (ev.defaultPrevented) { return; }' +
	'var target = (ev.target);' +
	'if (\'composedPath\' in ev) {' +
	'var path = ev.composedPath();' +
	'target = path.shift() || target;' +
	'}' +
	'if (!target || !isFormMethodDialog(target.form)) { return; }' +
	'var valid = (target.type === \'submit\' && [\'button\', \'input\'].indexOf(target.localName) > -1);' +
	'if (!valid) {' +
	'if (!(target.localName === \'input\' && target.type === \'image\')) { return; }' +
	'dialogPolyfill.imagemapUseValue = ev.offsetX + \',\' + ev.offsetY;' +
	'}' +
	'var dialog = findNearestDialog(target);' +
	'if (!dialog) { return; }' +
	'dialogPolyfill.formSubmitter = target;' +
	'}, false);' +
	'document.addEventListener(\'submit\', function(ev) {' +
	'var form = ev.target;' +
	'var dialog = findNearestDialog(form);' +
	'if (dialog) {' +
	'return;' +
	'}' +
	'var submitter = findFormSubmitter(ev);' +
	'var formmethod = submitter && submitter.getAttribute(\'formmethod\') || form.getAttribute(\'method\');' +
	'if (formmethod === \'dialog\') {' +
	'ev.preventDefault();' +
	'}' +
	'});' +
	'var nativeFormSubmit = HTMLFormElement.prototype.submit;' +
	'var replacementFormSubmit = function () {' +
	'if (!isFormMethodDialog(this)) {' +
	'return nativeFormSubmit.call(this);' +
	'}' +
	'var dialog = findNearestDialog(this);' +
	'dialog && dialog.close();' +
	'};' +
	'HTMLFormElement.prototype.submit = replacementFormSubmit;' +
	'}' +
	'return dialogPolyfill;' +
	'}));';
	
	eval(jsDialogPolyfill);
}